package com.example.demo.method.service;

import com.example.demo.method.domain.IMethod;
import com.example.demo.method.domain.MethodString;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

@Service
public class MethodService {
    private final ApplicationContext applicationContext;

    public MethodService(ApplicationContext applicationContext) {
        this.applicationContext = applicationContext;
    }

    public String Sum(Object first, Object second, String type) {
        final IMethod operation = (IMethod) applicationContext.getBean(type);
        if (operation instanceof MethodString)
            return String.format("%s", operation.Sum(first,second));
        else

            return String.format("%s", operation.Sum(Integer.parseInt(first.toString()),Integer.parseInt(second.toString())));
    }

    public String Min(Object first, Object second, String type) {
        final IMethod operation = (IMethod) applicationContext.getBean(type);
        if (operation instanceof MethodString)
            return String.format("%s", operation.Min(first,second));
        else
            return String.format("%s", operation.Min(Integer.parseInt(first.toString()),Integer.parseInt(second.toString())));
    }

    public String Mult(Object first, Object second, String type) {
        final IMethod operation = (IMethod) applicationContext.getBean(type);
        if (operation instanceof MethodString)
            return String.format("%s", operation.Mult(first,second));
        else
            return String.format("%s", operation.Mult(Integer.parseInt(first.toString()),Integer.parseInt(second.toString())));
    }

    public String Div(Object first, Object second, String type) {
        final IMethod operation = (IMethod) applicationContext.getBean(type);
        if (operation instanceof MethodString)
            return String.format("%s", operation.Div(first,second));
        else
            return String.format("%s", operation.Div(Integer.parseInt(first.toString()),Integer.parseInt(second.toString())));
    }
}
