package com.example.demo.speaker.controller;

import com.example.demo.speaker.service.SpeakerService;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class SpeakerController {
    private final SpeakerService speakerService;
    public SpeakerController(SpeakerService speakerService){
        this.speakerService = speakerService;
    }

    @GetMapping("/hello")
    public String hello(@RequestParam(defaultValue = "мир") String name,
                        @RequestParam(defaultValue = "ru") String lang){
        return speakerService.say(name, lang);
    }

    @GetMapping("/sum")
    public @ResponseBody Integer sum(@RequestParam(required = false, defaultValue = "0") int val1,
                                     @RequestParam(required = false, defaultValue = "0") int val2){
        return val1 + val2;
    }

    @GetMapping("/toLowerCase")
    public @ResponseBody String toLowerCase(@RequestParam(defaultValue = "TO LOW CASE") String value) {
        return value.toLowerCase();
    }

    @GetMapping("/minus")
    public @ResponseBody Integer minus(@RequestParam(required = false, defaultValue = "0") int val1,
                                       @RequestParam(required = false, defaultValue = "0") int val2){
        return val1 - val2;
    }

    @GetMapping("/join")
    public @ResponseBody String join(@RequestParam(required = false, defaultValue = "0") String str1,
                                     @RequestParam(required = false, defaultValue = "0") String str2){
        return String.join("", str1, str2);
    }
}
