package com.example.demo.supply.controllers;

import com.example.demo.supply.models.Product;
import com.example.demo.supply.services.ProductService;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@CrossOrigin
@RequestMapping("/product")
public class ProductController {

    private final ProductService productService;

    public ProductController(ProductService productService) {
        this.productService = productService;
    }

    @GetMapping("/{id}")
    public Product getProduct(@PathVariable Long id) {
        return productService.findProduct(id);
    }

    @GetMapping("/")
    public List<Product> getProduct() {
        return productService.findAllProducts();
    }

    @PostMapping("/")
    public Product createStudent(@RequestParam() String name,
                                 @RequestParam() float cost) {
        return productService.addProduct(name, cost);
    }

    @PatchMapping("/{id}")
    public Product updateProduct(@PathVariable Long id,
                                 @RequestParam() String name,
                                 @RequestParam() float cost) {
        return productService.updateProduct(id, name, cost);
    }

    @DeleteMapping("/{id}")
    public Product deleteProduct(@PathVariable Long id) {
        return productService.deleteProduct(id);
    }
}
