package com.example.demo;

import com.example.demo.method.service.MethodService;
import com.example.demo.speaker.service.SpeakerService;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.NoSuchBeanDefinitionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
class DemoApplicationTests {
	@Autowired
	MethodService methodService;
	@Test
	void testSumInt() {
		final String res = methodService.Sum(12, 12, "int");
		Assertions.assertEquals(24, Integer.parseInt(res));
	}

	@Test
	void testMinInt() {
		final String res = methodService.Min(12, 12, "int");
		Assertions.assertEquals(0, Integer.parseInt(res));
	}

	@Test
	void testMultInt() {
		final String res = methodService.Mult(2, 3, "int");
		Assertions.assertEquals(6, Integer.parseInt(res));
	}

	@Test
	void testDivInt() {
		final String res = methodService.Div(12, 6, "int");
		Assertions.assertEquals(2, Integer.parseInt(res));
	}
	@Test
	void testSumStr() {
		final String res = methodService.Sum("12", "12", "str");
		Assertions.assertEquals("12+12", res);
	}

	@Test
	void testMinStr() {
		final String res = methodService.Min("12", "12", "str");
		Assertions.assertEquals("12-12", res);
	}
	@Test
	void testMultStr() {
		final String res = methodService.Mult("12", "12", "str");
		Assertions.assertEquals("12*12", res);
	}
	@Test
	void testDivStr() {
		final String res = methodService.Div("12", "12", "str");
		Assertions.assertEquals("12/12", res);
	}

	@Test
	void testNoSuchBean() {
		Assertions.assertThrows(NoSuchBeanDefinitionException.class, () -> methodService.Min("12", "12", "string"));
	}

	@Test
	void testNumFormatError() {
		Assertions.assertThrows(NumberFormatException.class, () -> methodService.Min("12dd", 12, "int"));
	}


}
